
var Thumbnail = function()
{
	var thumb = {};
	var HOME = null;
	
	// Add click handler to thumbnail images in the list page
	thumb.initElements = function(element, autoInit)
	{
		if (autoInit == 'thumbnail') 
		{
			Events.addEventHandler(element, 'click', thumb.showImage);
			element.title = 'Click to show full image';
			if (element.complete)
			{
				thumb.imageLoaded(element);
			}
			else
			{
				Events.addEventHandler(element, 'load', thumb.onImageLoaded);
			}
		}
		else if (autoInit == 'thumbnail-proxy')
		{
			// The image file info is on the proxy element
			// An <img> is created and inserted as a child to the 'target' element
			var fileId = Data.int(element, 'file-id');
			var size = Data.get(element, 'size', 'XLARGE');
			var rotate = Data.get(element, 'rotate');
			var imageIndex = Data.int(element, 'image-index', -1);
			var target = Data.get(element, 'target', 'main.properties.content');
			
			var home = thumb.getHome();
			var url = home + 'Thumbnails.servlet?ID='+App.getSessionId();
			url += '&file='+fileId;
			url += '&size='+size;
			if (rotate) url += '&rotate='+rotate;
			if (imageIndex >= 0) url += '&index='+imageIndex;
			
			var img = document.createElement('img');
			img.src = url;
			img.className = 'thumbnail-img thumbnail-view '+size.toLowerCase()+' loading';
			Data.set(img, 'file-id', fileId);
			Events.addEventHandler(img, 'click', thumb.showImage);
			Events.addEventHandler(img, 'load', thumb.onImageLoaded);
			
			Doc.element(target).appendChild(img);
			Doc.hide(element.parentNode);
		}
	}
	
	// Find the <script> tag for 'thumbnail.js' and extract the path to it
	thumb.getHome = function()
	{
		if (HOME != null) return HOME;
		
		var scripts = document.getElementsByTagName('script');
		for (var i = scripts.length - 1; i >= 0; i--)
		{
			var src = scripts[i].src;
			var end = src.indexOf('thumbnails.js');
			if (end > 0)
			{
				var start = src.indexOf(App.getRoot());
				HOME = src.substring(start, end);
			}
		}
		// Fallback that should never happen!
		if (HOME == null) HOME = App.getRoot() + 'extensions/thumbnails.jar/';
		return HOME;
	}
	
	// Show the full image when a thumbnail is clicked
	thumb.showImage = function(event)
	{
		var fileId = Data.int(event.currentTarget, 'file-id');
		
		var controller = Items.getController('FILE');
		var url = App.getRoot() + controller.url;
		url += '?ID='+App.getSessionId();
		url += '&cmd=ViewFile&item_id='+fileId;

		var options = 'toolbar=no,location=no,directories=no,status=no,menubar=no,scrollbars=yes,resizable=yes';
		window.open(url, 'FullImage'+fileId, options);
	}
	
	thumb.onImageLoaded = function(event)
	{
		thumb.imageLoaded(event.currentTarget);
	}
	
	thumb.imageLoaded = function(element)
	{
		Doc.removeClass(element, 'loading');
	}
	
	return thumb;
}();

Doc.addElementInitializer(Thumbnail.initElements);
